/**
 * @license
 * @version 0.9.0
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
define("router5",[],function(){var e=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||false;n.configurable=true;if("value"in n)n.writable=true;Object.defineProperty(e,n.key,n)}}return function(t,r,n){if(r)e(t.prototype,r);if(n)e(t,n);return t}}();function t(e,t){if(!(e instanceof t)){throw new TypeError("Cannot call a class as a function")}}var r=function r(e){return"("+(e?e.replace(/(^<|>$)/g,""):"[a-zA-Z0-9-_.~]+")+")"};var n=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(e){return new RegExp(r(e[2]))}},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(e){return new RegExp(";"+e[1]+"="+r(e[2]))}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function a(e){return new RegExp("\\"+e[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function a(e){return new RegExp(e[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function a(e){return new RegExp(e[0])}}];var i=function i(e){var t=arguments.length<=1||arguments[1]===undefined?[]:arguments[1];var r=n.some(function(r){var n=e.match(r.pattern);if(!n)return false;t.push({type:r.name,match:n[0],val:n.slice(1,2),otherVal:n.slice(2),regex:r.regex instanceof Function?r.regex(n):r.regex});if(n[0].length<e.length)t=i(e.substr(n[0].length),t);return true});if(!r){throw new Error("Could not parse path.")}return t};var u=function u(e,t){if(!t)return e;return e.replace(/\\\/$/,"")+"(?:\\/)?"};var s=function s(e,t){var r=arguments.length<=2||arguments[2]===undefined?"":arguments[2];var n=e[t];if(n===undefined)e[t]=r;else e[t]=Array.isArray(n)?n.concat(r):[n,r];return e};var o=function o(e){var t=e.split("?")[1];if(!t)return{};return t.split("&").map(function(e){return e.split("=")}).reduce(function(e,t){return s(e,t[0],t[1])},{})};var l=function l(e){return e!==undefined&&e!==null&&e!==""?"="+e:""};var f=function f(e,t){return Array.isArray(t)?t.map(function(t){return f(e,t)}).join("&"):e+l(t)};var c=function(){e(l,null,[{key:"createPath",value:function n(e){return new l(e)}},{key:"serialise",value:function a(e,t){return f(e,t)}}]);function l(e){t(this,l);if(!e)throw new Error("Please supply a path");this.path=e;this.tokens=i(e);this.hasUrlParams=this.tokens.filter(function(e){return/^url-parameter/.test(e.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(e){return/splat$/.test(e.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(e){return/matrix$/.test(e.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(e){return e.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(e){return/^url-parameter/.test(e.type)}).map(function(e){return e.val.slice(0,1)}).reduce(function(e,t){return e.concat(t)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(e){return e.type==="query-parameter"}).map(function(e){return e.val}).reduce(function(e,t){return e.concat(t)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(e){return e.regex!==undefined}).map(function(e){return e.regex.source}).join("")}e(l,[{key:"_urlMatch",value:function c(e,t){var r=this;var n=e.match(t);if(!n)return null;else if(!this.urlParams.length)return{};return n.slice(1,this.urlParams.length+1).reduce(function(e,t,n){e[r.urlParams[n]]=t;return e},{})}},{key:"match",value:function h(e){var t=this;var r=arguments.length<=1||arguments[1]===undefined?0:arguments[1];var n=u(this.source,r);var a=this._urlMatch(e,new RegExp("^"+n+(this.hasQueryParams?"\\?.*$":"$")));if(!a||!this.hasQueryParams)return a;var i=o(e);var s=Object.keys(i).filter(function(e){return t.queryParams.indexOf(e)===-1});if(s.length===0){Object.keys(i).forEach(function(e){return a[e]=i[e]});return a}return null}},{key:"partialMatch",value:function v(e){var t=this;var r=arguments.length<=1||arguments[1]===undefined?0:arguments[1];var n=u(this.source,r);var a=this._urlMatch(e,new RegExp("^"+n));if(!a)return a;if(!this.hasQueryParams)return a;var i=o(e);Object.keys(i).filter(function(e){return t.queryParams.indexOf(e)>=0}).forEach(function(e){return s(a,e,i[e])});return a}},{key:"build",value:function m(){var e=arguments.length<=0||arguments[0]===undefined?{}:arguments[0];var t=arguments.length<=1||arguments[1]===undefined?{ignoreConstraints:false,ignoreSearch:false}:arguments[1];if(this.urlParams.some(function(t){return e[t]===undefined}))throw new Error("Missing parameters");if(!t.ignoreConstraints){var n=this.tokens.filter(function(e){return/^url-parameter/.test(e.type)&&!/-splat$/.test(e.type)}).every(function(t){return new RegExp("^"+r(t.otherVal[0])+"$").test(e[t.val])});if(!n)throw new Error("Some parameters are of invalid format")}var a=this.tokens.filter(function(e){return e.type!=="query-parameter"}).map(function(t){if(t.type==="url-parameter-matrix")return";"+t.val[0]+"="+e[t.val[0]];return/^url-parameter/.test(t.type)?e[t.val[0]]:t.match}).join("");if(t.ignoreSearch)return a;var i=this.queryParams.filter(function(t){return Object.keys(e).indexOf(t)!==-1}).map(function(t){return f(t,e[t])}).join("&");return a+(i?"?"+i:"")}}]);return l}();var h=function(){function e(e,t){var r=[];var n=true;var a=false;var i=undefined;try{for(var u=e[Symbol.iterator](),s;!(n=(s=u.next()).done);n=true){r.push(s.value);if(t&&r.length===t)break}}catch(o){a=true;i=o}finally{try{if(!n&&u["return"])u["return"]()}finally{if(a)throw i}}return r}return function(t,r){if(Array.isArray(t)){return t}else if(Symbol.iterator in Object(t)){return e(t,r)}else{throw new TypeError("Invalid attempt to destructure non-iterable instance")}}}();var v=function v(e){return e!==undefined&&e!==null&&e!==""};var m=function m(e,t){if(e.indexOf("?")===-1)return e;var r=e.split("?");var n=h(r,2);var a=n[0];var i=n[1];var u=i.split("&").reduce(function(e,r){var n=r.split("=");var a=h(n,2);var i=a[0];var u=a[1];if(t.indexOf(i)===-1)e[i]=u||"";return e},{});var s=Object.keys(u).map(function(e){return[e].concat(v(u[e])?u[e]:[])}).map(function(e){return e.join("=")}).join("&");return a+(s?"?"+s:"")};var d=function(){function r(){var e=arguments.length<=0||arguments[0]===undefined?"":arguments[0];var n=arguments.length<=1||arguments[1]===undefined?"":arguments[1];var a=arguments.length<=2||arguments[2]===undefined?[]:arguments[2];t(this,r);this.name=e;this.path=n;this.parser=n?new c(n):null;this.children=[];this.add(a);return this}e(r,[{key:"add",value:function n(e){var t=this;if(e===undefined||e===null)return;if(e instanceof Array){e.forEach(function(e){return t.add(e)});return}if(!(e instanceof r)&&!(e instanceof Object)){throw new Error("RouteNode.add() expects routes to be an Object or an instance of RouteNode.")}if(e instanceof Object){if(!e.name||!e.path){throw new Error("RouteNode.add() expects routes to have a name and a path defined.")}e=new r(e.name,e.path,e.children)}if(this.children.map(function(e){return e.name}).indexOf(e.name)!==-1){throw new Error('Alias "'+e.name+'" is already defined in route node')}if(this.children.map(function(e){return e.path}).indexOf(e.path)!==-1){throw new Error('Path "'+e.path+'" is already defined in route node')}var n=e.name.split(".");if(n.length===1){this.children.push(e);this.children.sort(function(e,t){if(e.path==="/")return 1;if(t.path==="/")return-1;var r=e.parser.hasUrlParams||e.parser.hasSpatParam;var n=t.parser.hasUrlParams||t.parser.hasSpatParam;if(!r&&!n){return e.path&&t.path?e.path.length<t.path.length?1:-1:0}if(r&&!n)return 1;if(!r&&n)return-1;if(!e.parser.hasSpatParam&&t.parser.hasSpatParam)return-1;if(!t.parser.hasSpatParam&&e.parser.hasSpatParam)return 1;var a=(e.path.match(/\//g)||[]).length;var i=(t.path.match(/\//g)||[]).length;if(a<i)return 1;return 0})}else{var a=this.getSegmentsByName(n.slice(0,-1).join("."));if(a){a[a.length-1].add(new r(n[n.length-1],e.path,e.children))}else{throw new Error("Could not add route named '"+e.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(e,t){this.add(new r(e,t));return this}},{key:"getSegmentsByName",value:function i(e){var t=function t(e,t){var r=t.filter(function(t){return t.name===e});return r.length?r[0]:undefined};var r=[];var n=e.split(".");var a=this.children;var i=n.every(function(e){var n=t(e,a);if(n){a=n.children;r.push(n);return true}return false});return i?r:null}},{key:"getSegmentsMatchingPath",value:function u(e){var t=arguments.length<=1||arguments[1]===undefined?false:arguments[1];var r=function r(e,n,a){var i=function(i){var u=e[i];var s=u.parser.partialMatch(n);var o=undefined,l=undefined;if(!s&&t){s=u.parser.match(n,true);o=""}else if(s){var f=u.parser.build(s,{ignoreSearch:true});o=m(n.replace(f,""),u.parser.queryParams);if(t&&o==="/"&&!/\/$/.test(f)){o=""}}if(s){a.push(u);Object.keys(s).forEach(function(e){return a.params[e]=s[e]});if(!o.length){return{v:a}}if(!u.children.length){return{v:null}}return{v:r(u.children,o,a)}}};for(var u in e){var s=i(u);if(typeof s==="object")return s.v}return null};var n=this.parser?[this]:this.children;var a=[];a.params={};return r(n,e,a)}},{key:"getPathFromSegments",value:function s(e){return e?e.map(function(e){return e.path}).join(""):null}},{key:"getPath",value:function o(e){return this.getPathFromSegments(this.getSegmentsByName(e))}},{key:"buildPathFromSegments",value:function l(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];if(!e)return null;var r=e.filter(function(e){return e.parser.hasQueryParams}).map(function(e){return e.parser.queryParams});var n=!r.length?null:r.reduce(function(e,t){return e.concat(t)}).filter(function(e){return Object.keys(t).indexOf(e)!==-1}).map(function(e){return c.serialise(e,t[e])}).join("&");return e.map(function(e){return e.parser.build(t,{ignoreSearch:true})}).join("")+(n?"?"+n:"")}},{key:"buildPath",value:function f(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(e),t)}},{key:"getMatchPathFromSegments",value:function h(e){if(!e||!e.length)return null;var t=e.map(function(e){return e.name}).join(".");var r=e.params;return{name:t,params:r}}},{key:"matchPath",value:function v(e){var t=arguments.length<=1||arguments[1]===undefined?false:arguments[1];return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(e,t))}}]);return r}();var p={ROUTER_NOT_STARTED:"NOT_STARTED",ROUTER_ALREADY_STARTED:"ALREADY_STARTED",ROUTE_NOT_FOUND:"ROUTE_NOT_FOUND",SAME_STATES:"SAME_STATES",CANNOT_DEACTIVATE:"CANNOT_DEACTIVATE",CANNOT_ACTIVATE:"CANNOT_ACTIVATE",TRANSITION_ERR:"TRANSITION_ERR",NODE_LISTENER_ERR:"NODE_ERR",TRANSITION_CANCELLED:"CANCELLED"};function g(){var e=arguments;return function(){return e[0]}}var y=function y(){};var S=typeof window!=="undefined";var _=function _(){return window.location.pathname.replace(/\/$/,"")};var E=function E(e,t,r){return window.history.pushState(e,t,r)};var w=function w(e,t,r){return window.history.replaceState(e,t,r)};var k=function k(e){return window.addEventListener("popstate",e)};var A=function A(e){return window.removeEventListener("popstate",e)};var T=function T(e){var t=e.useHash?window.location.hash.replace(new RegExp("^#"+e.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+e.base),"");return t+window.location.search};var b=function b(){return window.history.state};var P={};if(S){P={getBase:_,pushState:E,replaceState:w,addPopstateListener:k,removePopstateListener:A,getLocation:T,getState:b}}else{P={getBase:g(""),pushState:y,replaceState:y,addPopstateListener:y,removePopstateListener:y,getLocation:g(""),getState:g(null)}}function N(e,t,r,n,a){var i=arguments.length<=5||arguments[5]===undefined?false:arguments[5];e=e||function(){return false};var u=t||[];var s=function s(e){if(!u.length)return true;var t=u[0].length;var a=u[0](r,n,e);if(typeof a==="boolean"){e(a?null:true)}else if(a&&typeof a.then==="function"){a.then(function(){return e(null)},function(){return e(true)})}else if(t<3&&i){e(null)}return false};var o=function o(e){if(e)a(e);else{u=u.slice(1);l()}};var l=function l(){if(e()){a(null)}else{var t=s(o);if(t)a(null)}};l()}function R(e,t){var r=function r(e){return e.split(".").reduce(function(e,t){return e.concat(e.length?e[e.length-1]+"."+t:t)},[])};var n=undefined;var a=t?r(t.name):[];var i=r(e.name);var u=Math.min(a.length,i.length);if(t&&t.name===e.name)n=Math.max(u-1,0);else{for(n=0;n<u;n+=1){if(a[n]!==i[n])break}}var s=a.slice(n).reverse();var o=i.slice(n);var l=t&&n>0?a[n-1]:"";return{intersection:l,toDeactivate:s,toActivate:o}}function O(e,t,r,n){var a=false;var i=function i(){return a};var u=function u(){return a=true};var s=function s(e){return n(a?p.TRANSITION_CANCELLED:e)};var o=R(t,r);var l=o.intersection;var f=o.toDeactivate;var c=o.toActivate;var h=function h(t,r,n){var a=f.map(function(t){return e._cmps[t]}).filter(function(e){return e&&e.canDeactivate}).map(function(e){return e.canDeactivate});N(i,a,t,r,function(e){return n(e?p.CANNOT_DEACTIVATE:null)})};var v=function v(t,r,n){var a=c.map(function(t){return e._canAct[t]}).filter(function(e){return e});N(i,a,t,r,function(e){return n(e?p.CANNOT_ACTIVATE:null)})};var m=e._onTr;var d=function d(e,t,r){var n=[m];N(i,n,e,t,function(e){return r(e?p.TRANSITION_ERR:null)})};var g=e._cbs["^"+l];var y=function y(e,t,r){var n=g;N(i,n,e,t,function(e){return r(e?p.NODE_LISTENER_ERR:null)},true)};var S=(r?[h]:[]).concat(v).concat(m?d:[]).concat(g&&g.length?y:[]);N(i,S,t,r,s);return u}var h=function(){function e(e,t){var r=[];var n=true;var a=false;var i=undefined;try{for(var u=e[Symbol.iterator](),s;!(n=(s=u.next()).done);n=true){r.push(s.value);if(t&&r.length===t)break}}catch(o){a=true;i=o}finally{try{if(!n&&u["return"])u["return"]()}finally{if(a)throw i}}return r}return function(t,r){if(Array.isArray(t)){return t}else if(Symbol.iterator in Object(t)){return e(t,r)}else{throw new TypeError("Invalid attempt to destructure non-iterable instance")}}}();var L=Array.prototype.slice;var e=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||false;n.configurable=true;if("value"in n)n.writable=true;Object.defineProperty(e,n.key,n)}}return function(t,r,n){if(r)e(t.prototype,r);if(n)e(t,n);return t}}();function t(e,t){if(!(e instanceof t)){throw new TypeError("Cannot call a class as a function")}}var x=function x(e,t,r){return{name:e,params:t,path:r}};var C=function(){e(r,null,[{key:"ERR",value:p,enumerable:true},{key:"transitionPath",value:R,enumerable:true}]);function r(e){var n=this;var a=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];t(this,r);this.started=false;this._onTr=null;this._cbs={};this._cmps={};this._canAct={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=e instanceof d?e:new d("","",e);this.options={useHash:false,hashPrefix:"",base:"",trailingSlash:0};Object.keys(a).forEach(function(e){return n.options[e]=a[e]});this._setBase();this.boundOnPopState=this.onPopState.bind(this)}e(r,[{key:"_setBase",value:function n(){if(this.options.useHash&&!this.options.base)this.options.base=P.getBase()}},{key:"setOption",value:function a(e,t){this.options[e]=t;if(e==="useHash")this._setBase();return this}},{key:"add",value:function i(e){this.rootNode.add(e);return this}},{key:"addNode",value:function u(e,t,r){this.rootNode.addNode(e,t);if(r)this._canAct[e]=r;return this}},{key:"onPopState",value:function s(e){var t=this;var r=!e.state||!e.state.name;var n=e.state||this.matchPath(this.getLocation());var a=this.options;if(!n){this.navigate(a.defaultRoute,a.defaultParams,{reload:true,replace:true});return}if(this.lastKnownState&&this.areStatesEqual(n,this.lastKnownState)){return}this._transition(n,this.lastKnownState,function(e,i){if(e){if(e===p.CANNOT_DEACTIVATE){var u=t.buildUrl(t.lastKnownState.name,t.lastKnownState.params);if(!r){t.updateBrowserState(n,u,true)}}else{t.navigate(a.defaultRoute,a.defaultParams,{reload:true,replace:true})}}else{t.updateBrowserState(i,t.buildUrl(i.name,i.params),r)}})}},{key:"onTransition",value:function o(e){this._onTr=e;return this}},{key:"start",value:function l(){var e=this;var t=[].concat(L.call(arguments));var r=t.slice(-1)[0];var n=r instanceof Function?r:null;var a=undefined,i=undefined;if(this.started){if(n)n(p.ROUTER_ALREADY_STARTED);return this}if(t.length>0){if(typeof t[0]==="string")a=t[0];if(typeof t[0]==="object")i=t[0]}this.started=true;var u=this.options;var s=function s(t,r){var a=arguments.length<=2||arguments[2]===undefined?true:arguments[2];P.addPopstateListener(e.boundOnPopState);if(n)n(t,r);if(t&&a)e._invokeListeners("$error",r,null,t)};if(!a&&!i)a=this.getLocation();if(!i){(function(){i=e.matchPath(a);var t=function t(){return e.navigate(u.defaultRoute,u.defaultParams,{replace:true},function(e,t){return s(e,t,false)})};if(i){e.lastStateAttempt=i;e._transition(e.lastStateAttempt,e.lastKnownState,function(r,n){if(!r){e.updateBrowserState(e.lastKnownState,e.buildUrl(i.name,i.params),true);s(null,n)}else if(u.defaultRoute)t();else s(r,null,false)})}else if(u.defaultRoute){t()}else{s(p.ROUTE_NOT_FOUND,null)}})()}else{this.lastKnownState=i;this.updateBrowserState(this.lastKnownState,this.buildUrl(i.name,i.params),true);s(null,i)}return this}},{key:"stop",value:function f(){if(!this.started)return this;this.lastKnownState=null;this.lastStateAttempt=null;this.started=false;P.removePopstateListener(this.boundOnPopState);return this}},{key:"getState",value:function c(){return this.lastKnownState}},{key:"isActive",value:function v(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];var r=arguments.length<=2||arguments[2]===undefined?false:arguments[2];var n=arguments.length<=3||arguments[3]===undefined?true:arguments[3];var a=this.getState();if(!a)return false;if(r||a.name===e){return this.areStatesEqual(x(e,t),a,n)}return this.areStatesDescendants(x(e,t),a)}},{key:"areStatesEqual",value:function m(e,t){var r=this;var n=arguments.length<=2||arguments[2]===undefined?true:arguments[2];if(e.name!==t.name)return false;var a=function a(e){return r.rootNode.getSegmentsByName(e).map(function(e){return e.parser[n?"urlParams":"params"]}).reduce(function(e,t){return e.concat(t)},[])};var i=a(e.name);var u=a(t.name);return i.length===u.length&&i.every(function(r){return e.params[r]===t.params[r]})}},{key:"areStatesDescendants",value:function g(e,t){var r=new RegExp("^"+e.name+"\\.(.*)$");if(!r.test(t.name))return false;return Object.keys(e.params).every(function(r){return e.params[r]===t.params[r]})}},{key:"_invokeListeners",value:function y(e){for(var t=arguments.length,r=Array(t>1?t-1:0),n=1;n<t;n++){r[n-1]=arguments[n]}(this._cbs[e]||[]).forEach(function(e){return e.apply(undefined,r)})}},{key:"_addListener",value:function S(e,t,r){var n=e.replace(/^(\*|\^|=)/,"");if(n&&!/^\$/.test(e)){var a=this.rootNode.getSegmentsByName(n);if(!a)console.warn("No route found for "+n+", listener might never be called!")}if(!this._cbs[e])this._cbs[e]=[];this._cbs[e]=(r?[]:this._cbs[e]).concat(t);return this}},{key:"_removeListener",value:function _(e,t){if(this._cbs[e])this._cbs[e]=this._cbs[e].filter(function(e){return e!==t});return this}},{key:"addListener",value:function E(e){return this._addListener("*",e)}},{key:"removeListener",value:function w(e){return this._removeListener("*",e)}},{key:"addNodeListener",value:function k(e,t){return this._addListener("^"+e,t,true)}},{key:"removeNodeListener",value:function A(e,t){this._cbs["^"+e]=[];return this}},{key:"addRouteListener",value:function T(e,t){return this._addListener("="+e,t)}},{key:"removeRouteListener",value:function b(e,t){return this._removeListener("="+e,t)}},{key:"onTransitionStart",value:function N(e){return this._addListener("$start",e)}},{key:"offTransitionStart",value:function C(e){return this._removeListener("$start",e)}},{key:"onTransitionCancel",value:function D(e){return this._addListener("$cancel",e)}},{key:"offTransitionCancel",value:function j(e){return this._removeListener("$cancel",e)}},{key:"onTransitionError",value:function U(e){return this._addListener("$error",e)}},{key:"offTransitionError",value:function $(e){return this._removeListener("$error",e)}},{key:"registerComponent",value:function I(e,t){if(this._cmps[e])console.warn("A component was alread registered for route node "+e+".");this._cmps[e]=t;return this}},{key:"deregisterComponent",value:function B(e){delete this._cmps[e]}},{key:"canActivate",value:function K(e,t){this._canAct[e]=t;return this}},{key:"getLocation",value:function M(){return P.getLocation(this.options)}},{key:"buildUrl",value:function q(e,t){return this._buildUrl(this.rootNode.buildPath(e,t))}},{key:"_buildUrl",value:function F(e){return this.options.base+(this.options.useHash?"#"+this.options.hashPrefix:"")+e}},{key:"buildPath",value:function z(e,t){return this.rootNode.buildPath(e,t)}},{key:"matchPath",value:function Z(e){var t=this.rootNode.matchPath(e,this.options.trailingSlash);return t?x(t.name,t.params,e):null}},{key:"urlToPath",value:function V(e){var t=e.match(/^(?:http|https)\:\/\/(?:[0-9a-z_\-\.\:]+?)(?=\/)(.*)$/);var r=t?t[1]:e;var n=r.match(/^(.*?)(#.*?)?(\?.*)?$/);if(!n)throw new Error("Could not parse url "+e);var a=n.slice(1);var i=h(a,3);var u=i[0];var s=i[1];var o=i[2];var l=this.options;return(l.useHash?s.replace(new RegExp("^#"+l.hashPrefix),""):u.replace(new RegExp("^"+l.base),""))+(o||"")}},{key:"matchUrl",value:function H(e){return this.matchPath(this.urlToPath(e))}},{key:"_transition",value:function Q(e,t,r){var n=this;if(this._tr)this._tr();this._invokeListeners("$start",e,t);var a=O(this,e,t,function(a){n._tr=null;if(a){if(a===p.TRANSITION_CANCELLED)n._invokeListeners("$cancel",e,t);else n._invokeListeners("$error",e,t,a);if(r)r(a);return}n.lastKnownState=e;n._invokeListeners("="+e.name,e,t);n._invokeListeners("*",e,t);if(r)r(null,e)});this._tr=a;return function(){return!a||a()}}},{key:"navigate",value:function Y(e,t,r,n){if(t===undefined)t={};var a=this;if(r===undefined)r={};if(!this.started){if(n)n(p.ROUTER_NOT_STARTED);return}if(!P.getState())r.replace=true;var i=this.buildPath(e,t);var u=this.buildUrl(e,t);if(!i){if(n)n(p.ROUTE_NOT_FOUND);this._invokeListeners("$error",null,this.lastKnownState,p.ROUTE_NOT_FOUND);return}var s=x(e,t,i);this.lastStateAttempt=s;var o=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(o&&!r.reload){if(n)n(p.SAME_STATES);this._invokeListeners("$error",s,this.lastKnownState,p.SAME_STATES);return}return this._transition(s,o?null:this.lastKnownState,function(e,t){if(e){if(n)n(e);return}a.updateBrowserState(a.lastStateAttempt,u,r.replace);if(n)n(null,t)})}},{key:"updateBrowserState",value:function G(e,t){var r=arguments.length<=2||arguments[2]===undefined?false:arguments[2];var n=arguments.length<=3||arguments[3]===undefined?"":arguments[3];P[r?"replaceState":"pushState"](e,n,t)}}]);return r}();return{RouteNode:d,Router5:C}});